set echo on
break on deptno skip 1
clear screen
select deptno
     , ename
     , sal
     , rn
  from ( select deptno
              , ename
              , sal
              , row_number() over (partition by deptno order by sal desc) rn
              , rank() over (partition by deptno order by sal desc) rank
              , dense_rank() over (partition by deptno order by sal desc) dense_rank
           from emp
       )
 where rn <= 3
 order by deptno, sal desc

pause
/
pause
clear screen
select deptno
     , ename
     , sal
     , rank
  from ( select deptno
              , ename
              , sal
              , row_number() over (partition by deptno order by sal desc) rn
              , rank() over (partition by deptno order by sal desc) rank
              , dense_rank() over (partition by deptno order by sal desc) dense_rank
           from emp
       )
 where rank <= 3
 order by deptno, sal desc

pause
/
pause
clear screen
select deptno
     , ename
     , sal
     , dense_rank
  from ( select deptno
              , ename
              , sal
              , row_number() over (partition by deptno order by sal desc) rn
              , rank() over (partition by deptno order by sal desc) rank
              , dense_rank() over (partition by deptno order by sal desc) dense_rank
           from emp
       )
 where dense_rank <= 3
 order by deptno, sal desc

pause
/
set echo off
