set echo on
column formatted_phone_number format a22
clear screen
create table telephone_numbers (phone_number)
as
select '515-123-4444' from dual union all
select '515 123 4567' from dual union all
select '515 123-4568' from dual union all
select '515-123-4569' from dual union all
select '5151235555' from dual union all
select 'not a number' from dual
/
select phone_number
     , regexp_replace
       ( phone_number
       , '([[:digit:]]{3}).?([[:digit:]]{3}).?([[:digit:]]{4})'
       , '(\1) \2-\3'
       ) formatted_phone_number
  from telephone_numbers
/
set echo off
drop table telephone_numbers purge
/
