set echo on
column r1 format a40
column r2 format a40
column r3 format a40
column r4 format a40
set linesize 135
clear screen
create table t (text varchar2(40))
/
insert into t values ('Oracle University SQL Masterclass')
/
remark
remark  REPLACE(char,search_string,replacement_string)
remark
select text
     , replace(text,'SQL','PL/SQL') r1
     , replace(text,'er','ER')      r2
  from t
/
pause
remark
remark  REGEXP_REPLACE(source_char,pattern,replace_string,position,occurrence,match_parameter)
remark
select text
     , regexp_replace(text,'SQL','PL/SQL') r1
     , regexp_replace(text,'er','ER')      r2
  from t
/
pause
clear screen
remark
remark  4th parameter: position
remark
select text
     , regexp_replace(text,'er','ER')    r1
     , regexp_replace(text,'er','ER',15) r2
  from t
/
pause
clear screen
remark
remark  5th parameter: occurrence
remark
select text
     , regexp_replace(text,'er','ER',1,0) r1
     , regexp_replace(text,'er','ER',1,1) r2
     , regexp_replace(text,'er','ER',1,2) r3
     , regexp_replace(text,'er','ER',1,3) r4
  from t
/
pause
clear screen
remark
remark  6th parameter: match_parameter
remark
remark  'c': case sensitive
remark
select text
     , regexp_replace(text,'er','ER',1,0)     r1
     , regexp_replace(text,'er','ER',1,0,'c') r2
  from t
/
pause
remark
remark  'i': case sensitive
remark
select text
     , regexp_replace(text,'s','!S',1,0)     r1
     , regexp_replace(text,'s','!S',1,0,'i') r2
  from t
/

set echo off
drop table t purge
/
set linesize 135
