set echo on
column c1 format 999999999
column c2 format 999999999
column c3 format 999999999
column c4 format 999999999
clear screen
create table t (text varchar2(33))
/
insert into t values ('Oracle University SQL Masterclass')
/
select text
     , length(text) - length(replace(text,'s')) c1
  from t
/
pause
select text
     , length(regexp_replace(text,'[^s]')) c1
  from t
/
pause
select text
     , regexp_count(text,'s') c1
  from t
/
pause
clear screen
remark
remark  REGEXP_COUNT (source_char,pattern,position,match_param)
remark
select text
     , regexp_count(text,'s')  c1
     , regexp_count(text,'as') c2
  from t
/
pause
select text
     , regexp_count(text,'s',1)   c1
     , regexp_count(text,'as',1)  c2
     , regexp_count(text,'s',15)  c3
     , regexp_count(text,'as',15) c4
  from t
/
pause
select text
     , regexp_count(text,'s',1,'i')   c1
     , regexp_count(text,'as',1,'i')  c2
     , regexp_count(text,'s',15,'i')  c3
     , regexp_count(text,'as',15,'i') c4
  from t
/
pause
select text
     , regexp_count(text,'s',1,'c')   c1
     , regexp_count(text,'as',1,'c')  c2
     , regexp_count(text,'s',15,'c')  c3
     , regexp_count(text,'as',15,'c') c4
  from t
/
set echo off
drop table t purge
/
