set echo on
column i1 format 999
column i2 format 999
column i3 format 999
column i4 format 999
column s1 format a17
column s2 format a17
column s3 format a17
column s4 format a17
create table t (text varchar2(30))
/
insert into t values ('Oracle University 1234 S.Q.L.')
/
insert into t
select 'a' from dual union all
select 'aa' from dual union all
select 'aaa' from dual union all
select 'aaaa' from dual union all
select 'aaaaa' from dual union all
select 'aaaaaa' from dual union all
select 'aaaaaaa' from dual
/
select text
     , regexp_instr(text,'a*?a',1,1)  i1
     , regexp_substr(text,'a*?a',1,1) s1
     , regexp_instr(text,'a*a',1,1)   i2
     , regexp_substr(text,'a*a',1,1)  s2
  from t
/
pause
select text
     , regexp_instr(text,'a+?a',1,1)  i1
     , regexp_substr(text,'a+?a',1,1) s1
     , regexp_instr(text,'a+a',1,1)   i2
     , regexp_substr(text,'a+a',1,1)  s2
  from t
/
pause
select text
     , regexp_instr(text,'a??a',1,1)  i1
     , regexp_substr(text,'a??a',1,1) s1
     , regexp_instr(text,'a?a',1,1)   i2
     , regexp_substr(text,'a?a',1,1)  s2
  from t
/
delete t
 where text like 'a%'
/
pause
select text
     , regexp_instr(text,'\w*?i',1,1)  i1
     , regexp_substr(text,'\w*?i',1,1) s1
     , regexp_instr(text,'\w*i',1,1)   i2
     , regexp_substr(text,'\w*i',1,1)  s2
  from t
/
pause
select text
     , regexp_instr(text,'\w+?i',1,1)  i1
     , regexp_substr(text,'\w+?i',1,1) s1
     , regexp_instr(text,'\w+i',1,1)   i2
     , regexp_substr(text,'\w+i',1,1)  s2
  from t
/
pause
select text
     , regexp_instr(text,'\w??i',1,1)  i1
     , regexp_substr(text,'\w??i',1,1) s1
     , regexp_instr(text,'\w?i',1,1)   i2
     , regexp_substr(text,'\w?i',1,1)  s2
  from t
/
pause
insert into t
select 'a' from dual union all
select 'aa' from dual union all
select 'aaa' from dual union all
select 'aaaa' from dual union all
select 'aaaaa' from dual union all
select 'aaaaaa' from dual union all
select 'aaaaaaa' from dual
/
select text
     , regexp_instr(text,'a{2}?',1,1)  i1
     , regexp_substr(text,'a{2}?',1,1) s1
     , regexp_instr(text,'a{2}',1,1)   i2
     , regexp_substr(text,'a{2}',1,1)  s2
  from t
/
pause
select text
     , regexp_instr(text,'a{2,}?',1,1)  i1
     , regexp_substr(text,'a{2,}?',1,1) s1
     , regexp_instr(text,'a{2,}',1,1)   i2
     , regexp_substr(text,'a{2,}',1,1)  s2
  from t
/
pause
select text
     , regexp_instr(text,'a{2,3}?',1,1)  i1
     , regexp_substr(text,'a{2,3}?',1,1) s1
     , regexp_instr(text,'a{2,3}',1,1)   i2
     , regexp_substr(text,'a{2,3}',1,1)  s2
  from t
/
delete t
 where text like 'a%'
/
set echo off
drop table t purge
/
