set echo on
select d.deptno
     , d.dname
     , sum(e.sal) sumsal
     , avg(e.sal) avgsal
  from dept d
       left outer join emp e on d.deptno = e.deptno
 group by d.deptno
     , d.dname
 order by d.deptno
/
pause
with sumsal as
( select e.deptno
       , sum(e.sal)
    from emp e
   group by e.deptno
)
select *
  from sumsal
/
pause
with sumsal as
( select e.deptno
       , sum(e.sal) sal
    from emp e
   group by e.deptno
)
, avgsal as
( select e.deptno
       , avg(e.sal) sal
    from emp e
   group by e.deptno
)
select d.deptno
     , d.dname
     , s.sal
     , a.sal
  from dept d
       left outer join sumsal s on d.deptno = s.deptno
       left outer join avgsal a on d.deptno = a.deptno
 order by d.deptno
/
set echo off
