set echo on
column drecord format a60
clear screen
select xmlquery
       ( 'for $i in fn:collection("oradb:/RWIJK/EMP")
            , $j in fn:collection("oradb:/RWIJK/DEPT")
          where $i/ROW/DEPTNO = $j/ROW/DEPTNO
          return $j'
          returning content
       ) as xml
  from dual
/
pause
clear screen
Create table dummy (Pidm number(9,0)
,orgn varchar2(6)
,title varchar2(20)
,Lastname varchar2(20)
,Firstname varchar2(20));
 
Insert into dummy(pidm,orgn,title,lastname,Firstname)
   values(649,'3601','Assoc. VP','Doe','Jane');
Insert into dummy(pidm,orgn,title,lastname,Firstname)
   values(649,'3555','Finance Admin','Doe','Jane');
Insert into dummy(pidm,orgn,title,lastname,Firstname)
   values(649,'3575','General Expense','Doe','Jane');
select *
  from dummy
/
pause
select c.orgn deptorg
     , rpad(t.column_value.getrootelement(),20) || ': ' || t.column_value.extract('//text()') drecord
  from dummy c
     , table
       ( xmlsequence
         ( xmltype
           ( cursor
             ( select d.orgn deptorg
                    , d.*
                 from dummy d
                where d.orgn = c.orgn
             )
           ).extract('ROWSET/ROW/*')
         )
       ) t
 where c.pidm = 649
 order by c.orgn
     , t.column_value.getrootelement()
/ 
pause
select x1.deptorg
     , rpad(x2.col_name,20) || ': ' || x2.col_value as drecord
  from xmltable
       ( '/ROWSET/ROW'
         passing dbms_xmlgen.getxmltype('select C.Orgn Deptorg,C.* from dummy C where C.pidm=649')
         columns deptorg varchar2(30) path 'DEPTORG'
               , cols    xmltype      path '.'
       ) x1
     , xmltable
       ( 'for $i in /ROW/*
          return element e
          {
            attribute name {local-name($i)},
            $i/text()
          }'
         passing x1.cols
         columns col_name  varchar2(30) path '@name'
               , col_value varchar2(30) path '.'
       ) x2
/
/*
pause
select extractvalue(column_value, 'e/*[1]') orgn
     , x.column_value.extract('e/*[2]').getrootelement() name
     , extractvalue(column_value, 'e/*[2]') value 
  from xmltable
       ( 'for $i in ./ROW/*
          return <e>{$i/../ORGN}{$i}</e>' 
         passing xmltype(cursor(select d.* from dummy d where pidm = 649)).extract('ROWSET/ROW') 
       ) x
/
*/
set echo off
drop table dummy purge
/
