********************************************************************************
 select deptno
      , substr(max(sys_connect_by_path(ename, ',' )),2) enames_achter_elkaar
   from ( select deptno
               , ename
               , row_number() over (partition by deptno order by ename) rn
            from grote_emp
        )
  start with rn = 1
connect by prior rn = rn-1
    and prior deptno = deptno
  group by deptno
  order by deptno

call count cpu elapsed disk query current rows
------ ---------- ----------
Parse 1 0.00 0.00 0 0 0 0
Execute 1 0.00 0.00 0 0 0 0
Fetch 31 5.04 10.20 9038 5012 2 30000
------ ---------- ----------
total 33 5.04 10.20 9038 5012 2 30000

Misses in library cache during parse: 0
Optimizer mode: ALL_ROWS
Parsing user id: 61

Rows Row Source Operation
30000 SORT GROUP BY (cr=5012 pr=9038 pw=9038 time=8327268 us)
140000 CONNECT BY WITH FILTERING (cr=5012 pr=35 pw=35 time=5026711 us)
30000 FILTER (cr=716 pr=0 pw=0 time=823950 us)
140000 COUNT (cr=716 pr=0 pw=0 time=2433935 us)
140000 VIEW (cr=716 pr=0 pw=0 time=1604675 us)
140000 WINDOW SORT (cr=716 pr=0 pw=0 time=758165 us)
140000 TABLE ACCESS FULL GROTE_EMP (cr=716 pr=0 pw=0 time=560085 us)
110000 HASH JOIN (cr=4296 pr=35 pw=35 time=3891016 us)
140000 CONNECT BY PUMP (cr=0 pr=0 pw=0 time=560076 us)
840000 COUNT (cr=4296 pr=0 pw=0 time=14600811 us)
840000 VIEW (cr=4296 pr=0 pw=0 time=9559357 us)
840000 WINDOW SORT (cr=4296 pr=0 pw=0 time=5359294 us)
840000 TABLE ACCESS FULL GROTE_EMP (cr=4296 pr=0 pw=0 time=3360438 us)
0 COUNT (cr=0 pr=0 pw=0 time=0 us)
0 VIEW (cr=0 pr=0 pw=0 time=0 us)
0 WINDOW SORT (cr=0 pr=0 pw=0 time=0 us)
0 TABLE ACCESS FULL GROTE_EMP (cr=0 pr=0 pw=0 time=0 us)

Waited
SQL*Net message to client 31 0.00 0.00
direct path write temp 478 0.15 1.90
direct path read temp 2485 0.05 2.77
SQL*Net message from client 31 0.01 0.41
SQL*Net more data to client 511 0.00 0.03

********************************************************************************

select deptno
     , stragg(ename) enames_achter_elkaar
  from grote_emp
 group by deptno
 order by deptno

call count cpu elapsed disk query current rows
------ ---------- ----------
Parse 1 0.00 0.00 0 0 0 0
Execute 1 0.00 0.00 0 0 0 0
Fetch 31 13.89 13.94 0 716 0 30000
------ ---------- ----------
total 33 13.89 13.94 0 716 0 30000

Misses in library cache during parse: 0
Optimizer mode: ALL_ROWS
Parsing user id: 61
Rows Row Source Operation
30000 SORT GROUP BY (cr=716 pr=0 pw=0 time=14028921 us)
140000 TABLE ACCESS FULL GROTE_EMP (cr=716 pr=0 pw=0 time=560056 us)
Waited
SQL*Net message to client 31 0.00 0.00
SQL*Net message from client 31 0.01 0.30
SQL*Net more data to client 511 0.00 0.01
********************************************************************************
with t as
( select deptno
, substr(ename,2) ename
from grote_emp
model
partition by (deptno)
dimension by (row_number() over (partition by deptno order by ename) rn)
measures (cast(ename as varchar2(40)) ename)
rules
( ename[any] order by rn = ename[cv()-1] || ',' || ename[cv()]
)
)
select deptno
, max(ename) enames_achter_elkaar
from t
group by deptno
order by deptno
call count cpu elapsed disk query current rows
------
----------
----------
Parse 1 0.00 0.00 0 0 0 0
Execute 1 0.00 0.00 0 0 0 0
Fetch 31 1.96 1.97 0 716 0 30000
------
----------
----------
total 33 1.96 1.97 0 716 0 30000
Misses in library cache during parse: 0
Optimizer mode: ALL_ROWS
Parsing user id: 61
Rows Row Source Operation
30000 SORT GROUP BY (cr=716 pr=0 pw=0 time=2080124 us)
140000 VIEW (cr=716 pr=0 pw=0 time=1993654 us)
140000 SQL MODEL ORDERED (cr=716 pr=0 pw=0 time=1153638 us)
140000 WINDOW SORT (cr=716 pr=0 pw=0 time=751592 us)
140000 TABLE ACCESS FULL GROTE_EMP (cr=716 pr=0 pw=0 time=560077 us)
Waited
SQL*Net message to client 31 0.00 0.00
SQL*Net message from client 31 0.01 0.25
SQL*Net more data to client 511 0.00 0.01
********************************************************************************
with t as
( select deptno
, substr(ename,2) ename
, rn
from grote_emp
model
partition by (deptno)
dimension by (row_number() over (partition by deptno order by ename desc) rn)
measures (cast(ename as varchar2(4000)) ename)
rules
( ename[any] order by rn desc = ename[cv()+1] || ',' || ename[cv()]
)
)
select deptno
, ename enames_achter_elkaar
from t
where rn = 1
order by deptno
call count cpu elapsed disk query current rows
------
----------
----------
Parse 1 0.00 0.00 0 0 0 0
Execute 1 0.00 0.00 0 0 0 0
Fetch 31 7.18 225.50 69363 716 0 30000
------
----------
----------
total 33 7.18 225.50 69363 716 0 30000
Misses in library cache during parse: 0
Optimizer mode: ALL_ROWS
Parsing user id: 61
Rows Row Source Operation
30000 SORT ORDER BY (cr=716 pr=69363 pw=69363 time=225566028 us)
30000 VIEW (cr=716 pr=69363 pw=69363 time=76049371 us)
140000 SQL MODEL ORDERED (cr=716 pr=69363 pw=69363 time=230388256 us)
140000 WINDOW SORT (cr=716 pr=0 pw=0 time=1200652 us)
140000 TABLE ACCESS FULL GROTE_EMP (cr=716 pr=0 pw=0 time=560075 us)
Waited
SQL*Net message to client 31 0.00 0.00
direct path write temp 9909 0.50 71.32
direct path read temp 9909 0.31 146.74
SQL*Net message from client 31 0.01 0.33
SQL*Net more data to client 511 0.00 0.01
********************************************************************************
with t as
( select deptno
, substr(ename,2) ename
, rn
from grote_emp
model
partition by (deptno)
dimension by (row_number() over (partition by deptno order by ename desc) rn)
measures (cast(ename as varchar2(40)) ename)
rules
( ename[any] order by rn desc = ename[cv()+1] || ',' || ename[cv()]
)
)
select deptno
, ename enames_achter_elkaar
from t
where rn = 1
order by deptno
call count cpu elapsed disk query current rows
------
----------
----------
Parse 1 0.00 0.00 0 0 0 0
Execute 1 0.00 0.00 0 0 0 0
Fetch 31 1.85 1.90 0 716 0 30000
------
----------
----------
total 33 1.85 1.90 0 716 0 30000
Misses in library cache during parse: 0
Optimizer mode: ALL_ROWS
Parsing user id: 61
Rows Row Source Operation
30000 SORT ORDER BY (cr=716 pr=0 pw=0 time=1971450 us)
30000 VIEW (cr=716 pr=0 pw=0 time=885173 us)
140000 SQL MODEL ORDERED (cr=716 pr=0 pw=0 time=1205149 us)
140000 WINDOW SORT (cr=716 pr=0 pw=0 time=781130 us)
140000 TABLE ACCESS FULL GROTE_EMP (cr=716 pr=0 pw=0 time=560075 us)
Waited
SQL*Net message to client 31 0.00 0.00
SQL*Net message from client 31 0.01 0.25
SQL*Net more data to client 511 0.00 0.01
********************************************************************************
select deptno
, to_string(cast(collect(ename) as varchar2_ntt)) enames_achter_elkaar
from grote_emp
group by deptno
order by deptno
call count cpu elapsed disk query current rows
------
----------
----------
Parse 1 0.00 0.00 0 0 0 0
Execute 1 0.00 0.00 0 0 0 0
Fetch 31 1.92 1.91 0 716 0 30000
------
----------
----------
total 33 1.92 1.91 0 716 0 30000
Misses in library cache during parse: 0
Optimizer mode: ALL_ROWS
Parsing user id: 61
Rows Row Source Operation
30000 SORT GROUP BY (cr=716 pr=0 pw=0 time=999450 us)
140000 TABLE ACCESS FULL GROTE_EMP (cr=716 pr=0 pw=0 time=560056 us)
Waited
SQL*Net message to client 31 0.00 0.00
SQL*Net message from client 31 0.01 0.30
SQL*Net more data to client 511 0.00 0.01
********************************************************************************
select deptno
, rtrim(extract(xmlagg(xmlelement("X",ename || ',')), '/X/text()'),',') enames_achter_elkaar
from grote_emp
group by deptno
order by deptno
call count cpu elapsed disk query current rows
------
----------
----------
Parse 1 0.00 0.00 0 0 0 0
Execute 1 0.00 0.00 0 0 0 0
Fetch 31 24.28 24.33 0 719 0 30000
------
----------
----------
total 33 24.28 24.33 0 719 0 30000
Misses in library cache during parse: 0
Optimizer mode: ALL_ROWS
Parsing user id: 61
Rows Row Source Operation
30000 SORT GROUP BY (cr=716 pr=0 pw=0 time=12429254 us)
140000 TABLE ACCESS FULL GROTE_EMP (cr=716 pr=0 pw=0 time=560102 us)
Waited
SQL*Net message to client 31 0.00 0.00
SQL*Net message from client 31 0.01 0.30
SQL*Net more data to client 511 0.00 0.02
