set echo on
clear screen
set autotrace on explain
select d.deptno
     , d.dname
     , e.empno
     , e.ename
  from dept d
     , emp e
 where d.deptno = e.deptno (+)
/
pause
clear screen
select d.deptno
     , d.dname
     , e.empno
     , e.ename
  from dept d
       left outer join emp e on d.deptno = e.deptno
/
pause
clear screen
select d.deptno
     , d.dname
     , e.empno
     , e.ename
  from emp e 
       right outer join dept d on d.deptno = e.deptno
/
pause
set autotrace off
clear screen
select d.deptno
     , d.dname
     , e.empno
     , e.ename
  from dept d
       left outer join emp e on d.deptno = e.deptno
 where d.deptno in (10,40)
/
pause
select d.deptno
     , d.dname
     , e.empno
     , e.ename
  from dept d
       left outer join emp e on d.deptno = e.deptno and d.deptno in (10,40)
/
pause
select d.deptno
     , d.dname
     , ed.empno
     , ed.ename
  from dept d
     , ( select e.deptno
              , e.empno
              , e.ename
           from emp e
          where e.deptno in (10,40)
       ) ed
 where d.deptno = ed.deptno (+)
/
set echo off
