set echo on
set serveroutput off
set numwidth 10
clear screen
select /*+ gather_plan_statistics */
       deptno
     , job
     , sum(sal)
  from emp
 group by cube(deptno,job)
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'iostats last'))
/
pause
select deptno
     , job
     , sum(sal) sumsal
  from emp
 group by deptno , job
/
pause
with emp_after_first_sortgroupby as
( select deptno
       , job
       , sum(sal) sumsal
    from emp
   group by deptno , job
)
select deptno, job, sumsal from emp_after_first_sortgroupby
union all
select deptno,null, sumsal from emp_after_first_sortgroupby
union all
select null  , job, sumsal from emp_after_first_sortgroupby
union all
select null  ,null, sumsal from emp_after_first_sortgroupby
/
pause
with emp_after_first_sortgroupby as
( select deptno
       , job
       , sum(sal) sumsal
    from emp
   group by deptno , job
)
, emp_after_generate_cube as
( select deptno, job, sumsal from emp_after_first_sortgroupby
  union all
  select deptno,null, sumsal from emp_after_first_sortgroupby
  union all
  select null  , job, sumsal from emp_after_first_sortgroupby
  union all
  select null  ,null, sumsal from emp_after_first_sortgroupby
)
select deptno
     , job
     , sum(sumsal)
  from emp_after_generate_cube
 group by deptno
     , job
/
set echo off
set serveroutput on
set numwidth 38
