set echo on
clear screen
CREATE TABLE otn (id# INT, a INT, b INT, c INT, d INT)
/ 
INSERT ALL
INTO otn VALUES (1, 1, 8, 1, 99)
INTO otn VALUES (2, 1, 13, 2, 98)
INTO otn VALUES (3, 2, 21, 3, 96)
INTO otn VALUES (4, 3, 34, 4, 96)
INTO otn VALUES (5, 5, 55, 5, 95)
SELECT * FROM DUAL
/
select * from otn
/
remark
remark  Compute a new column E that contains:
remark   * the value of column D when A=1
remark   * the previous value of E + the value of column B when A=2
remark   * the previous value of E + the value of column C when A=3
remark   * NULL otherwise
remark
pause 
select a, b, c, d, e
  from otn
 model
       dimension by (id#)
       measures (a,b,c,d,0 e)
       rules
       ( e[any] = case a[cv()]
                  when 1 then d[cv()]
                  when 2 then e[cv()-1] + b[cv()]
                  when 3 then e[cv()-1] + c[cv()]
                  else null
                  end
       )
 order by id#
/
set echo off
drop table otn purge
/
