set echo on
column empno format 99999
select empno
     , ename
     , hiredate
     , m
  from emp
 model
       partition by (empno,ename,hiredate)
       dimension by (0 i)
       measures (trunc(hiredate,'mm') m)
       ( m[for i from 1 to months_between(date '1988-01-01',m[0]) increment 1]
         = m[0] + numtoyminterval(cv(i),'month')
       )
 order by ename
     , m
/
set echo off
