set echo on
clear screen
create table sales_view (prod,year,sales)
as
select 'vcr', 1999, 1 from dual union all
select 'vcr', 2000, 5 from dual union all
select 'vcr', 2001, 9 from dual union all
select 'dvd', 1999, 2 from dual union all
select 'dvd', 2000, 6 from dual union all
select 'dvd', 2001, 0 from dual union all
select 'tv', 1999, 3 from dual union all
select 'tv', 2000, 7 from dual union all
select 'tv', 2001, 1 from dual union all
select 'pc', 1999, 4 from dual union all
select 'pc', 2000, 8 from dual union all
select 'pc', 2001, 2 from dual
/
select *
  from sales_view
/
pause
clear screen
select *
  from sales_view
 model
       dimension by (prod,year)
       measures (sales s)
       rules upsert
       ( s[any, 2000] = s[cv(prod), cv(year -1]*2]
       , s[vcr, 2002] = s[vcr,2001] + s[vcr, 2000]
       , s[dvd, 2002] = avg(s)[cv(prod), year<2001]
       )
/
pause
select *
  from sales_view
 model
       dimension by (prod,year)
       measures (sales s)
       rules upsert
       ( s[any, 2000] = s[cv(prod), cv(year)-1] * 2
       , s[vcr, 2002] = s[vcr,2001] + s[vcr, 2000]
       , s[dvd, 2002] = avg(s)[cv(prod), year<2001]
       )
/
pause
clear screen
select *
  from sales_view
 model
       dimension by (prod,year)
       measures (sales s)
       rules upsert
       ( s[any, 2000] = s[cv(prod), cv(year)-1] * 2
       , s['vcr', 2002] = s['vcr',2001] + s['vcr', 2000]
       , s['dvd', 2002] = avg(s)[cv(prod), year<2001]
       )
 order by prod,year
/
set echo off
drop table sales_view purge
/
