set echo on
create table t (text varchar2(33))
/
insert into t values ('Oracle University SQL Masterclass')
/
insert into t values ('2 days')
/
--clear screen
select text
  from t
/
remark
remark  LIKE
remark
select text
  from t
 where text like 'S'
/
select text
  from t
 where text like '%S'
/
select text
  from t
 where text like 'S%'
/
select text
  from t
 where text like '%S%'
/
pause
--clear screen
remark
remark  REGEXP_LIKE (source_char,pattern,match_param)
remark
select text
  from t
 where regexp_like (text,'S')
/
pause
select text
  from t
 where text like '%S%'
    or text like 'Q'
    or text like '%L'
    or text like 'M%'
/
select text
  from t
 where regexp_like(text,'S|^Q$|L$|^M')
/
pause
remark
remark  3th parameter: match_param
remark
remark  'c': case sensitive
remark  'i': case insensitive
remark  'x': ignores whitespace characters
remark  'm': multiline mode; treats the source string as multiple lines
remark  'n': allows the period (.), which is the match-any-character character, to match the newline character
remark
select text
  from t
 where regexp_like(text,'S')
/
pause
select text
  from t
 where regexp_like(text,'S','c')
/
pause
select text
  from t
 where regexp_like(text,'S','i')
/
set echo off
drop table t purge
/