set echo on
column i1 format 999
column i2 format 999
column i3 format 999
column i4 format 999
column s1 format a17
column s2 format a17
column s3 format a17
column s4 format a17
create table t (text varchar2(30))
/
insert into t values ('Oracle University 1234 S.Q.L.')
/
select text
     , regexp_instr(text,'\d+')           i1
     , regexp_substr(text,'\d+')          s1
     , regexp_instr(text,'[[:digit:]]+')  i2
     , regexp_substr(text,'[[:digit:]]+') s2
  from t
/
pause
select text
     , regexp_instr(text,'\D+',1,1)            i1
     , regexp_substr(text,'\D+',1,1)           s1
     , regexp_instr(text,'\D+',1,2)            i2
     , regexp_substr(text,'\D+',1,2)           s2
     , regexp_instr(text,'[^[:digit:]]+',1,1)  i3
     , regexp_substr(text,'[^[:digit:]]+',1,1) s3
     , regexp_instr(text,'[^[:digit:]]+',1,2)  i4
     , regexp_substr(text,'[^[:digit:]]+',1,2) s4
  from t
/
pause
select text
     , regexp_instr(text,'\w+',1,1)            i1
     , regexp_substr(text,'\w+',1,1)           s1
     , regexp_instr(text,'\w+',1,3)            i2
     , regexp_substr(text,'\w+',1,3)           s2
     , regexp_instr(text,'[[:alnum:]_]+',1,1)  i3
     , regexp_substr(text,'[[:alnum:]_]+',1,1) s3
     , regexp_instr(text,'[[:alnum:]_]+',1,3)  i4
     , regexp_substr(text,'[[:alnum:]_]+',1,3) s4
  from t
/
pause
select text
     , regexp_instr(text,'\W+',1,1)             i1
     , regexp_substr(text,'\W+',1,1)            s1
     , regexp_instr(text,'\W+',1,2)             i2
     , regexp_substr(text,'\W+',1,2)            s2
     , regexp_instr(text,'[^[:alnum:]_]+',1,1)  i3
     , regexp_substr(text,'[^[:alnum:]_]+',1,1) s3
     , regexp_instr(text,'[^[:alnum:]_]+',1,2)  i4
     , regexp_substr(text,'[^[:alnum:]_]+',1,2) s4
  from t
/
pause
select text
     , regexp_instr(text,'\s+',1,1)           i1
     , regexp_substr(text,'\s+',1,1)          s1
     , regexp_instr(text,'\s+',1,2)           i2
     , regexp_substr(text,'\s+',1,2)          s2
     , regexp_instr(text,'[[:space:]]+',1,1)  i3
     , regexp_substr(text,'[[:space:]]+',1,1) s3
     , regexp_instr(text,'[[:space:]]+',1,2)  i4
     , regexp_substr(text,'[[:space:]]+',1,2) s4
  from t
/
pause
select text
     , regexp_instr(text,'\S+',1,1)            i1
     , regexp_substr(text,'\S+',1,1)           s1
     , regexp_instr(text,'\S+',1,2)            i2
     , regexp_substr(text,'\S+',1,2)           s2
     , regexp_instr(text,'[^[:space:]]+',1,1)  i3
     , regexp_substr(text,'[^[:space:]]+',1,1) s3
     , regexp_instr(text,'[^[:space:]]+',1,2)  i4
     , regexp_substr(text,'[^[:space:]]+',1,2) s4
  from t
/
pause
insert into t values ('Multiple
Line')
/
select text
     , regexp_instr(text,'\AO',1,1,0,'m') i1
     , regexp_substr(text,'\AO',1,1,'m')  s1
     , regexp_instr(text,'\AM',1,1,0,'m') i2
     , regexp_substr(text,'\AM',1,1,'m')  s2
     , regexp_instr(text,'\AL',1,1,0,'m') i3
     , regexp_substr(text,'\AL',1,1,'m')  s3
  from t
/
pause
select text
     , regexp_instr(text,'.\Z',1,1,0,'m') i1
     , regexp_substr(text,'.\Z',1,1,'m')  s1
     , regexp_instr(text,'.\z',1,1,0,'m') i2
     , regexp_substr(text,'.\z',1,1,'m')  s2
  from t
/
delete t
 where text like 'Multiple%'
/
set echo off
drop table t purge
/
