set echo on
column ename format a20
clear screen
update emp
   set mgr = 7566
 where ename = 'KING'
/
with emps (ename,empno,mgr,deptno) as
( select ename
       , empno
       , mgr
       , deptno
    from emp
   where ename = 'KING'
   union all
  select emp.ename
       , emp.empno
       , emp.mgr
       , emp.deptno
    from emp
         join emps on (emp.mgr = emps.empno)
) search depth first by deptno set a
  cycle empno set is_cycle to 'A' default 'B'
select ename
     , empno
     , mgr
     , deptno
     , a
     , is_cycle
  from emps
 order by a
/
rollback
/
set echo off
