set echo on
create table myemp as select * from emp
/
create table mydept as select * from dept
/
alter table myemp add (cumulative_sal number(6))
/
pause
select empno
     , sal
     , hiredate
     , cumulative_sal
  from myemp
 order by hiredate
     , empno
/
pause
update myemp x
   set cumulative_sal =
       ( select sumsal
           from ( select sum(sal) over (order by hiredate,empno) sumsal
                       , empno
                    from myemp
                )
          where empno = x.empno
       )
/        
pause
select empno
     , sal
     , hiredate
     , cumulative_sal
  from myemp
 order by hiredate
     , empno
/
pause
rollback
/
alter session set statistics_level = all
/
set serveroutput off
update myemp x
   set cumulative_sal =
       ( select sumsal
           from ( select sum(sal) over (order by hiredate,empno) sumsal
                       , empno
                    from myemp
                )
          where empno = x.empno
       )
/        
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause
rollback
/
merge into myemp x
using ( select sum(sal) over (order by hiredate,empno) sumsal
             , empno
          from myemp
      ) y
   on ( x.empno = y.empno )
 when matched then
      update set cumulative_sal = y.sumsal
/
pause
select * from table(dbms_xplan.display_cursor(null,null,'allstats last'))
/
pause
select empno
     , sal
     , hiredate
     , cumulative_sal
  from myemp
 order by hiredate
     , empno
/
pause
rollback
/
set serveroutput on
alter session set statistics_level = typical
/
set echo off
drop table myemp purge
/
drop table mydept purge
/
