set echo on
clear screen
select xmlelement
       ( "Employees"
       , xmlagg
         ( xmlelement
           ( "Employee"
           , xmlforest
             ( ename  as "Name"
             , job    as "Job"
             , deptno as "Department"
             )
           ) order by ename
         )
       ) xml
  from emp
/
pause
select xmlserialize
       ( document xmlelement
         ( "Employees"
         , xmlagg
           ( xmlelement
             ( "Employee"
             , xmlforest
               ( ename  as "Name"
               , job    as "Job"
               , deptno as "Department"
               )
             ) order by ename
           ) as clob indent size = 2
         )
       ) xml
  from emp
/
pause
select xmlelement
       ( "Employees"
       , xmlagg
         ( xmlelement
           ( "Employee"
           , xmlforest
             ( ename  as "Name"
             , job    as "Job"
             , deptno as "Department"
             )
           ) order by ename
         )
       ).extract('*') xml
  from emp
/
set echo off
