set echo on
column name format a10
column job format a10
column department format a10
clear screen
create table xml_to_process (x xmltype)
/
insert into xml_to_process
values (xmltype(
'<Employees>
  <Employee>
    <Name>ADAMS</Name>
    <Job>CLERK</Job>
    <Department>20</Department>
  </Employee>
  <Employee>
    <Name>ALLEN</Name>
    <Job>SALESMAN</Job>
    <Department>30</Department>
  </Employee>
  <Employee>
    <Name>BLAKE</Name>
    <Job>MANAGER</Job>
    <Department>30</Department>
  </Employee>
  <Employee>
    <Name>CLARK</Name>
    <Job>MANAGER</Job>
    <Department>10</Department>
  </Employee>
  <Employee>
    <Name>FORD</Name>
    <Job>ANALYST</Job>
    <Department>20</Department>
  </Employee>
</Employees>')
)
/
pause
select x
  from xml_to_process
/
pause
select xmlsequence(x)
  from xml_to_process
/
pause
select p.*
  from xml_to_process
     , table(xmlsequence(x)) p
/
pause
select p.*
  from xml_to_process
     , table(xmlsequence(extract(x,'Employees/*'))) p
/
pause
select extractvalue(column_value,'/Employee/Name')       name
     , extractvalue(column_value,'/Employee/Job')        job
     , extractvalue(column_value,'/Employee/Department') department
  from xml_to_process
     , table(xmlsequence(extract(x,'Employees/*'))) p
/
pause
select p.*
  from xml_to_process
     , table(xmlsequence(extract(x,'Employees/Employee/*'))) p
/
pause
select extractvalue(column_value,'/Name')       name
     , extractvalue(column_value,'/Job')        job
     , extractvalue(column_value,'/Department') department
  from xml_to_process
     , table(xmlsequence(extract(x,'Employees/Employee/*'))) p
/
set echo off
drop table xml_to_process purge
/
